%Finite Difference Methods to Solve Coupled PDEs in the Models
%Explicit Schemes
%By: Moch.Januar

% u: Nonlinear Source (Solitons)
% w: Conformational Changes

% pada t_1=0
for i=1:N
    u(1,i)=f(i);
end
for i=1:N
    w(1,i)=g(i);
end

% pada t_2=k 
for i=2:N-1
    w(2,i) = g(i) + (k^2)/2*((g(i+1)-2*g(i) + g(i-1))/(h^2) + 2*L*f(i)^2*g(i) - e^2*g(i));
end
for i=2:N-1
    u(2,i) = f(i) + (k^2)/2*((f(i+1)-2*f(i) + f(i-1)/(h^2) + 2*L*g(i)^2*f(i) - 3*l*f(i)^3));
end 

% untuk t_3 dan seterusnya  
% jika salah satu persamaan ditiadakan, iterasi pada persamaan lainnya tidak dapat berjalan
% sehingga kedua persamaan tersebut saling berkaitan
for j=2:M-1
    for i=2:N-1
        u(j+1,i) = 2*u(j,i)-u(j-1,i) + k^2*((u(j,i+1)-2*u(j,i) + u(j,i-1))/(h^2) + 2*L*w(j,i)^2*u(j,i)-3*l*u(j,i)^3);
        w(j+1,i) = 2*w(j,i)-w(j-1,i) + k^2*((w(j,i+1)-2*w(j,i) + w(j,i-1))/(h^2) + 2*L*u(j,i)^2*w(j,i)-e^2*w(j,i));              
    end
end


